/***************************************************************************
                          constants.h  -  description
                             -------------------
    begin                : Thu Feb 20 2003
    copyright            : (C) 2003 by Vinh Le Sy and Arndt von Haeseler
    email                : vinh@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONSTANT_H
#define CONSTANT_H
#include <math.h>
/*
The Constants.h contains all constant values for whole project.
Every constant values MUST BE declared here.

...Being specified more
*/



enum NEWICK_TREE_STATUS {WRONG_BRACKET_ORDER, NEWICK_TREE_FORM, MISSING_OPEN_BRACKET, MISSING_CLOSE_BRACKET, MISSING_FIRST_OPEN_BRACKET, MISSING_LAST_CLOSE_BRACKET, MISSING_COLON};
enum BOOLEAN {FALSE, TRUE};

const char BLANK = ' ';

const char BAD_MEMORY_ACCESS[] = "Accessed out of array. Please check the input data or contact the authors!!!";
const char PRO_VERSION[] = "Version 1.0";

const char MEMORY_LOCATION[] = "Out of memory!!!";


const char BAD_ASSIGNMENT[] = "Can not perform matrix A = matrix B while their rows and columns are different";

const char NEWICK_TREE_ALIGNMENT_ERROR[] = "the newick tree form and the alignment is not adaptive";

const char OUT_GRP_ND_ERROR[] = "the out group node is improper...";


const int PHYLIP_SEQ_NAME_LEN = 11;
const int MAX_NUM_REP = 100;


//the number of ANSSI character set
const int NUM_CHAR = 256;

const int FILENAME_LEN = 10000;
const int MAX_SEQ_NAME = 100;

//number digits after .
const int BR_LEN_PRECISION = 6;


//the last control charater
const int LAST_CONTROL_CHAR = 32;


//the INCREMENT is for vector template
const int INC = 4;

//the maximum number of sequences
const int MAX_NUM_SEQ = 100001;


const int INFINITIVE = 1000000000;

//the is the maximum length of a line in the alignment file
const int MAX_LINE_LEN = 100000;

//the maximum newich tree form length
const int MAX_NEWICK_TREE_LEN = 500000;

//the limits of branch length
const double MAX_BR_LEN = 9.00; /* upper limit on branch length */
const double MIN_BR_LEN = 0.000001; /* lower limit on branch length */

const double ZERO = 0.000000001;


#endif

