#ifndef INTERFACE_H
#define INTERFACE_H
#include <iostream>
#include <fstream>

#include "ali.h"

class Interface {

public :


void writeOut (const char *aliFile, Vec<char> &conTree, int nRepLea, double progTime, int dataSetNo) {

  std::ofstream outFile_;
  char outFileName_[FILENAME_LEN];
  strcpy (outFileName_, aliFile);

  char outTail_[FILENAME_LEN] = ".stc";
  strcat (outFileName_, outTail_);

  int nSeq_ = Ali::getNSeq ();
  if (dataSetNo > 1)
    outFile_.open (outFileName_, ios::app);
  else {
    outFile_.open (outFileName_);
    outFile_ << "THE RESULT IS FROM THE SHORTEST TRIPLET CLUSTERING ALGORITHM" << endl;
    outFile_ << "Number representatives: " << nRepLea << endl << endl;
  }

  outFile_ <<"Data set: " << dataSetNo << endl;
  outFile_ << "Number sequences: " << nSeq_ << endl;
  outFile_ <<"The tree topology as well as its edge lengths: " << endl;   
  OutStream::write (conTree, outFile_) << endl;

  


  int hour_ = static_cast<int> (progTime  / 3600.0);
  int min_ =  static_cast<int> ( (progTime - hour_ * 3600) / 60.0);
  int sec_ =  static_cast<int> ( progTime - hour_ * 3600 - min_ * 60);
  outFile_ << "Time consuming: " << hour_ << ":" << min_ << ":" << sec_ << endl << endl;
  outFile_.close ();


  char treeFileName_[FILENAME_LEN];
  strcpy (treeFileName_, aliFile);
  char outTailTree_[FILENAME_LEN] = ".stc.treefile";
  strcat (treeFileName_, outTailTree_);

  std::ofstream treeOutFile_;
  if (dataSetNo == 1)
    treeOutFile_.open (treeFileName_);
  else
    treeOutFile_.open (treeFileName_, ios::app);
  OutStream::write (conTree, treeOutFile_) << endl;
  treeOutFile_.close ();

  std::cout << "The results were written to " << outFileName_ << " and " << treeFileName_ << endl;
}



private:
int nSeq_;
};
#endif
    
