#ifndef OUTSTREAM_H
#define OUTSTREAM_H
#include <iostream>
#include <fstream>

#include "vec.h"
#include "mat.h"
#include "ali.h"

using namespace std;


extern std::ostream &operator << (std::ostream &out, Vec<char> &vec);
extern std::ofstream &operator << (std::ofstream &out, Vec<char> &vec);


class OutStream {
public :

//=================================================================
//write a vector
template <class T, class Tout>
static Tout &write (Vec<T> &vec, Tout &out) {
  if (sizeof (T) == 1) {
    for (int count_ = 0; count_ < vec.getSize (); count_ ++)
      out << vec[count_];
  } else {
    for (int count_ = 0; count_ < vec.getSize (); count_ ++) {
      out.precision (3);
      out.width (10);
      out << vec[count_];
    }
  }

  return out;
}


//=================================================================
//write the genetic distances of all two different sequences
template <class Tout>
static Tout &writeGenDis (double **mat, int nSeq, Tout &out) {
  int seqNo1_, seqNo2_;
  out << nSeq << endl;
  for (seqNo1_ = 0; seqNo1_ < nSeq; seqNo1_ ++) {
    out << Ali::getName (seqNo1_) << "  ";
    for (seqNo2_ = 0; seqNo2_ < nSeq; seqNo2_ ++) {
        out.precision (5);
        out.width (20);
        out << mat[seqNo1_][seqNo2_];
      }
    out << endl;  
  }    
//  out << "===============end of genetic distance matrix===============" << endl;

  return out;
}




//--------------------------------------------------------------------
//release the memory of this class
void release () {
}

//=================================================================
//the constructor functionn
virtual ~OutStream () {
  release ();
  std::cout << "this is the constructor of OutStream class " << endl;


}

}; //end ofthe class


#endif
