#ifndef ROOTEDTREE_H
#define ROOTEDTREE_H
#include "vec.h"
#include "mat.h"

class RootedTree {
public:
RootedTree ();
~RootedTree ();

void init (int seqNo);
void clean ();

int isLea ();
int getRoot ();

int getNeaSibNo ();
double getNeaSibDis ();

void setNeaSib (int neaSibNo, double neaSibDis);


RootedTree *getLChi ();
RootedTree *getRChi ();


void setFaBrLen (double faBrLen);
double getFaBrLen ();


void turnOff ();
void turnOn ();

Vec<int> *getLea ();
Vec<int> *getRepOutGrpNd ();

Vec<int> *getRepLea ();
Vec<double> *getRepDis ();


int isActive ();

void reCreateLea ();
void createLea ();
void createLea (int nRepLea);

//=============================================================
RootedTree *getNeiTree (RootedTree *chi);

void changeChi (RootedTree *oldChi, RootedTree *newChi);

int correct (int nRepLea);
int correct (RootedTree &faTree, int nRepLea);

void mergeTwoTree (int rootNo, int nRepLea, int outGrpNdNo, RootedTree *lChi, RootedTree *rChi);
//=======================================================
Vec<char> *getNwTree ();

void createNwTree ();
void createBrLen (int nRep);
void createNwTree (int outGrpNdNo, int nRepLea, Vec<char> &nwTree);
int createCloOutGrpNd (Vec<int> &canLeaArr0, Vec<int> &canLeaArr1, int nRepLea);

//=============================================================================
private:
int isNewTree_;

RootedTree *lChi_;
RootedTree *rChi_;

Vec<int> leaArr_;
Vec<int> repLeaArr_;
Vec<char> nwTree_;
Vec<int> repOutGrpNdArr_;
Vec<double> repDisArr_;

int rootNo_;
int isLea_;
int active_;

int neaSibNo_;
double neaSibDis_;

double faBrLen_;

//int repLea_;
//double repDis_;



int createRepLea (int nRepLea);

int findCloOutGrpNd ();
int findCloOutGrpNd (int nRepLea);


int createRepLea (Vec<int> &canLeaArr0, Vec<int> &canLeaArr1, int nRepLea, int outGrpNdNo);
//compute the observed distance among the outgrpnd and two representive colections
/*
void cmpOutGrpDis (Vec<double> &outGrpDisArr0, Vec<double> &outGrpDisArr1, Vec<double> &outGrpDisArr2, 
                                                    double &totalOutGrpDis0,
                                                    double &totalOutGrpDis1,
                                                    double &totalOutGrpDis2);
*/

//double cmpOutGrpDis (Vec<int> &outGrpArr, Vec<int> &lRepLeaArr, Vec<int> &rRepLeaArr, Vec<double> &outGrpDisArr);        
double cmpOutGrpDis (Vec<int> &outGrpArr, Vec<int> &lRepLeaArr, Vec<int> &rRepLeaArr);        
void   cmpSTCDis (double &outDis, double &lDis, double &rDis);        

void createRepLeaDis (int nRepLea);
void cmpNewTripletDis (int outGrpNdNo, int lRepLea, int rRepLea, double &disOx, double &disLx, double &disRx);
};
#endif
