
/***************************************************************************
                          sequence.cpp  -  description
                             -------------------
    begin                : Thu Feb 20 2003
    copyright            : (C) 2003 by Vinh Le Sy and Arndt von Haeseler
    email                : vinh@cs.uni-duesseldorf.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <string.h>
#include <ctype.h>
#include <iostream>
#include "seq.h"
#include "utl.h"
#include "constant.h"


extern int nto [NUM_CHAR];

//everything is inited here
void Seq::init () {
}

//--------------------------------------------------------------------
//the constructor
Seq::Seq () {
  id_ = -1;
}

//--------------------------------------------------------------------
//set identification for this sequence
void Seq::setId (const int id) {
  id_ = id;
}

//--------------------------------------------------------------------
//get the identification of this sequence
int Seq::getId () {
  return id_;
}

//--------------------------------------------------------------------
//get the name of this sequences from the line in the input file
int Seq::getName (char *aLine, Vec<char> &name) {
  int pos_ = 0;
  while (Utl::isControlChar (aLine [pos_]) == 1)
   pos_ ++;
  name.clean ();

  while (Utl::isControlChar (aLine[pos_]) == 0) {
      name += aLine[pos_];
      pos_ ++;
  }
  return pos_;
}





//--------------------------------------------------------------------
//copy the input sequence into this one
void Seq::operator = (Seq &seq) {
   //check, change the limit of this if the limit of this is smaller than the limit of vec
  if (&seq != this) {
    this->id_ = seq.getId ();

    if (limit_ < seq.getLimit ())
      setLimit(seq.getLimit () );


    this->name_ = seq.getName ();
  }
}


//--------------------------------------------------------------------------
//return the name of this sequence
Vec<char> &Seq::getName () {
  return name_;
}

void Seq::setName (char *name) {

  name_.set (PHYLIP_SEQ_NAME_LEN + 1, 0);
  for (int pos_ = 0; pos_ < PHYLIP_SEQ_NAME_LEN; pos_ ++) {
    if (Utl::isControlChar (name[pos_]) == 1)
      break;
    name_ += name[pos_];    
  }

  while (name_[name_.getSize () - 1] == BLANK)
    name_.delLastItem ();
}

//--------------------------------------------------------------------------
//release all memory of this class
void Seq::release () {
  name_.release ();
}

//--------------------------------------------------------------------
//destructor
Seq::~Seq () {
  //std::cout << "the destructor of seq " << endl;
}

