#include <cstring>
#include <fstream>
#include <math.h>
#include <iostream>
#include <time.h>
#include <ctime>

#include "testmethod.h"
#include "constant.h"
#include "ali.h"
#include "utl.h"
#include "outstream.h"
#include "interface.h"
#include "trigrp.h"

using namespace std;

//--------------------------------------------------------------------
//we will init all things here before starting testing this method with data
void TestMethod::init () {
}




//--------------------------------------------------------------------
/*do the quartet puzzling method for all data set from the input file
return the number of correct predicted tree
*/
int TestMethod::create (const char *aliFileName, 
                              int   nRepLea) {

//  long double start_ = clock ();
  
      
  //first, we read a data set into ali
  ifstream aliFile_;
  int status_ = Ali::readInput (aliFileName, aliFile_);

  if (status_ == 0) {
    std::cout << "The distance matrix is not in right format!!!";    
    return EXIT_SUCCESS;
  }

//   Ali::checkSameName ();
//  Ali::writeGenDis ();
  int nDataSet_ = 0;
  do {
    nDataSet_ ++;
    int nSeq_;
    time_t beginTime_;
    time (&beginTime_);

    nSeq_ = Ali::getNSeq ();
    nRepLea = Utl::getMax (1, nRepLea);
    if (nRepLea > Utl::getMin (nSeq_, MAX_NUM_REP) )
      nRepLea = Utl::getMin (nSeq_, MAX_NUM_REP);

    std::cout << "Reconstructing the tree for data set " << nDataSet_ << " (" << nSeq_ << " sequences)...\n";

    TriGrp triGrp_;
    Vec<char> tree_;
    triGrp_.createTree(tree_, nRepLea);

    Interface interface_;
    time_t endTime_;
    time (&endTime_);
    double progTime_ = difftime (endTime_, beginTime_);
    interface_.writeOut (aliFileName,  tree_, nRepLea, progTime_, nDataSet_);

    
    

    int isFirstDataSet_ = 0;
    status_ = Ali::readInputMatrix (aliFile_, isFirstDataSet_);
    
  } while (status_ == 1);

  aliFile_.close ();
  Ali::clean ();    
  return 1;
}
