#ifndef TRIGRP_H
#define TRIGRP_H
#include "rootedtree.h"
#include "vec.h"
#include "mat.h"


class TriGrp {
public:
TriGrp ();
~TriGrp ();



void createTree (Vec<char> &conTree, int nRepLea);
//===========================================
private:

int nCurTree_;
int nSeq_;
int outGrpNdNo_;
int nRepLea_;

Vec<RootedTree> itemArr_;
double **genDisMat_;

void init ();
void constructOneTree (int outGrpNdNo);

void clean ();
void init (int outGrpNdNo);

double cmpFaDis (int outGrpNdNo);
int findBestOutGrpNd ();

void findPairTree (int &rootNo1, int &rootNo2);
void updateSibInf (RootedTree &newTree, int oldLRootNo, int oldRRootNo);
double cmpOutGrpDis (int outGrpNdNo, int lNdNo, int rNdNo);
double cmpOutGrpDis (int outGrpNdNo, Vec<int> &lRepLeaArr, Vec<int> &rRepLeaArr);
};
#endif
